
% WHAT IF...? OUTPUT LAYER

% FIG 5 panels C to E

opengl software
figure;

%PANEL C

%THE NUMBER OF PC SPIKES RECEIVED BY A NUCLEAR CELL IN 1 ms, WITH AND 
%WITHOUT (5 ms) INTEGRATION, AT AN EXTRAPOLATED PC RATE OF 147.5 Hz. EVEN 
%WITHOUT INTEGRATION, THE NUMBER IS IN A MODEST AND RELIABLE RANGE. WITH
%INTEGRATION THE RANGE IS NARROWER AND TENDS TO A RECOGNISABLY NORMAL
%DISTRIBUTION. THE PC RATE IS SELECTED BECAUSE IT IS IN THE 
%PHYSIOLOGICAL RANGE AND OTHERWISE AT RANDOM. 

i=1;
el5s=[];
integ_el5s=[];

while i<51
    j=1;
    summed=zeros([1 200]);
    while j<41
        PC=array();
        summed=(summed+PC);
        j=j+1;
    end
    el5=summed([5]);
    el5s=[el5s el5]; %This builds into an array that is plotted as a 
    %histogram and also sampled for the third plot
    
    integ=integrate_all_intervals(summed)
    integ_el5=integ([5]);
    integ_el5s=[integ_el5s integ_el5]; %See previous comment
    
    i=i+1;
end

edges=[0.5 1.5 2.5 3.5 4.5 5.5 6.5 7.5 8.5 9.5];

subplot(2,4,1);
histogram(el5s,edges,'facecolor',[1 0 0],'facealpha',.2)
xlabel('spikes/ms');ylabel('nuclear cells');title('Mono');
ylim([0 45])% check ylim matches panel E
set(gca,'FontSize',10)

hold on 
histogram(integ_el5s,edges,'facecolor',[0 .45 .75],'facealpha',.3)

%PANEL E

%ILLUSTRATION OF THE HIGHLY FOCUSED EFFECT OF BISYNAPTIC CONVERGENCE ONTO 
%NUCLEAR CELLS EITHER VIA EXCITATORY INTERNEURONS OR NUCLEAR COLLATERALS.
%PC-CONTROLLED INTRA-NUCLEAR-GROUP EXCITATORY INPUT TO NUCLEAR CELLS HAS AN EFFECT 
%WITH A VERY NARROW RANGE OF VARIATION BY CHANCE WHICH IS THEREFORE BOTH AT
%ANY MOMENT THE SAME FOR ALL NUCLEAR CELLS IN A GROUP AND HIGHLY 
%REPRODUCIBLE. FOCUSING IS SHARP EVEN WITHOUT INTEGRATION (PINK) BUT 
%FURTHER SHARPENED WITH INTEGRATION ADDED (BLUE).

subplot(2,4,3)

n=1;
AAA=[]; BBB=[];

while n<10

    i=1;
    AA=[]; BB=[];

    while i<51
        A=randsample(el5s,5); %Randomly samples el5s, sample size 5
        AA=[AA; A]; %Builds into a 50x5 matrix of random samples of el5s, each
        %representing a nuclear cell
        B=randsample(integ_el5s,5); 
        BB=[BB; B]; 
        i=i+1;
    end

    AA=mean(AA,2)'; %Averages each row of the matrix AA and flips to an array of
    %50 elements, representing the sample mean for each of 50 nuclear cells
    BB=mean(BB,2)';
    AAA=[AAA; AA];%Builds into a matrix of nx50 sample means, representing n
    %examples of AA - AAA and BBB were originally used in an extra panel
    %(the commented code at the end of this file) which was not included in
    %the final figure. Both they, and the outer loop used to generate them,
    %are therefore redundant.
    BBB=[BBB; BB];
        
    n=n+1
end
%BB = integrate_all_intervals(BB);
histogram(AA,edges,'facecolor',[1 0 0],'facealpha',.2)
xlabel('effect of resampling');ylabel('nuclear cells');title('Di');
%xticklabels([0 2 4 6 8 10]) %doesn't wk!
ylim([0 45])
set(gca,'FontSize',10)
hold on
histogram(BB,edges,'facecolor',[0 .45 .75],'facealpha',.3)

%PANEL D

% PROBABILITY DISTRIBUTIONS FOR THE NUMBER OF PC SPIKES RECEIVED BY A
% NUCLEAR CELL IN 1 ms AT AN EXTRAPOLATED PC RATE OF 147.5 HZ, WITH AND
% WITHOUT (5 ms) INTEGRATION. THE DISTRIBUTIONS ARE BOTH NORMAL, WITH THE
% SAME MEAN. INTEGRATION NARROWS THE DISTRIBUTION (THE PEAK IS THINNER
% AND TALLER), REPRESENTING LOW VARIATION ACROSS A NUCLEAR GROUP AND HIGH 
% REPODUCIBILITY

k=1;
bigger=[];
%bigger=zeros([1 50]);
better=[];
%better=zeros([1 50]);

while k<51
    i=1;
    el5s=[];
    integ_el5s=[];
    while i<51
        j=1;
        summed=zeros([1 200]);
        while j<41
            PC=array();
            summed=(summed+PC);
            j=j+1;
        end
        el5=summed([5]);
        el5s=[el5s el5]; %An array of 50 elements, each representing the
        %number of PC spikes received by each of 50 nuclear cells in 1 ms, 
        %without integration
        
        integ=integrate_all_intervals(summed)
        integ_el5=integ([5]);
        integ_el5s=[integ_el5s integ_el5]; %The number of PC spikes
        %received by each of 50 nuclear cells in 1 ms, with integration

        i=i+1;
    end
    k=k+1;
    bigger=[bigger; el5s]; %A kx50 matrix
    better=[better; integ_el5s];
end

subplot(2,4,2)

[N,edges]=histcounts(bigger);
bigN = N
z = sum(N);
y = N/z;
x = [1:1:numel(y)];
bar(x,y,'BarWidth',1,'facecolor',[1 0 0],'facealpha',.2);
xlabel('spikes/ms');ylabel('p');title('Mono');
xlim([0 13]); 
set(gca,'FontSize',10)

% The next 3 lines remove every other x tick label
ax = gca; labels = string(ax.XAxis.TickLabels); % extract
labels(1:2:end) = nan; % remove every other one
ax.XAxis.TickLabels = labels; % set

hold on 

% The next (now double commented) line was necessary before the two bar 
% charts were combined in the same panel 
% % edges=[0.5 1.5 2.5 3.5 4.5 5.5 6.5 7.5 8.5 9.5]
[N,edges]=histcounts(better,edges);
% betN = N;
z = sum(N);
y = N/z; 
x = [1:1:numel(y)];
bar(x,y,'BarWidth',1,'facecolor',[0 .45 .75],'facealpha',.3)
