
% The function receives an array of length(x) elements

function remastered = integrate_all_intervals(x)

a = 2; % The number of elements to be averaged. This can be any number by 
% which length(x) is divisible
b = length(x)/a;
x = circshift(x,a-1);

i = 1;

while i <= length(x)

    makegrps = reshape(x, [], b); % The function reshape(x,n,m) receives an 
    % array x and returns a matrix of n rows and m columns. The first column 
    % is made up of the first n elements of the input array, the second is 
    % made up of the second n elements, and so on. 

    grps_av = mean(makegrps); % Average the values in each column, 
    % generating an array with m elements.

    x(a) = grps_av(1);
    
    x(end+1) = x(1); x = x(2:end); % Duplicate the first element of the 
    % input array at the end, then remove the first element, so that the 
    % elements are rotated by 1.
    
    i = i + 1;

end

x = circshift(x,length(x)-(a-1));

remastered = x;

% remastered = stack(:)'; % The colon converst the matrix stack into a single 
% % column - by putting the second column under the first, the third under the
% % second and so on - and the apostrophe flips the resulting single column 
% % into a row.

